const int debounce_delay = 50;  // ms
int carNS_Switch_state = LOW;
int carNS_Switch_prev = LOW;
int carEW_Switch_state = LOW;
int carEW_Switch_prev = LOW;
unsigned long carNS_last_debounce = 0;
unsigned long carEW_last_debounce = 0;

unsigned long timerStart;
unsigned long timerEnd = 0;

bool timerExpired = false;
/**
* A FSM controller for an Intersection.
* The core of the controller is the TrafficeLightsignal(short sensor) function
* which is called by the intersection every time a sensor
* is signalled.
* Group name:
* Student Id:                     Student Name:                     
* Student Id:                     Student Name:                     
* Student Id:                     Student Name:                    
* Student Id:                     Student Name:                    

*/


// possible actions that Arduino can perform on the intersection:  
// to set the E-W lights
//   turnEWred()
//   turnEWamber()
//   turnEWgreen()
// to set the N-S lights
//   turnNSred()     
//   turnNSamber()
//   turnNSgreen()
// to restart the timer, eg for 1 second (1000 milliseconds)
//   restartTimer(1000)  

// Receives a change in a sensor value that may trigger an action and state change.
// If there is a transition out of the current state associated with this sensor signal, 
//  - it will perform the appropriate action (if any)
//  - it will transition to the next state (by changing the state field)

//  possible sensor values that you should respond to:
//     carEW (HIGH or LOW)  carNS (HIGH or LOW)  timerExpired (true or flase)




String state  = "EW Go ready";     // Stores the current state of the FSM

// the number of the pushbutton pins
const int carNS_pin = 13; // switch is on pin 13
const int carEW_pin = 2;  // switch is on pin 2


// The number of the LED pins
// light EW
const int redEW = 6;
const int yellowEW = 5;
const int greenEW = 4;

// light NS
const int redNS = 12;
const int yellowNS = 11;
const int greenNS = 10;

void setup(){
  // initialize the LED pin as an output:
  pinMode(redEW, OUTPUT);
  pinMode(yellowEW, OUTPUT);
  pinMode(greenEW, OUTPUT);

  pinMode(redNS, OUTPUT);
  pinMode(yellowNS, OUTPUT);
  pinMode(greenNS, OUTPUT);

  // initialize the pushbutton pin as an input:
  pinMode(carNS_pin, INPUT);
  pinMode(carEW_pin, INPUT);

  // initialize the greenEW and redNS LEDs to high:
  digitalWrite(greenEW, HIGH);
  digitalWrite(redNS, HIGH);
}

void loop(){

  checkTimer();
  
  // Read the current position of both buttons (carNS, carEW)
  int carNS = readCarNS();
  int carEW = readCarEW();

  // actions and transitions
  if(state == "EW Go ready"){
    if(carNS == HIGH){
      turnEWamber();
      restartTimer(3000);
      state = "EW Stopping"; 
    }
  }
  else if(state == "EW Stopping"){ 
    /*YOUR CODE HERE*/




  }
  else if(state == "EW Stopping carEW"){   
    /*YOUR CODE HERE*/




  }
  else if(state == "NS Go"){
    /*YOUR CODE HERE*/




  }
  else if(state == "NS Go must change"){ 
    /*YOUR CODE HERE*/




  }
  else if(state == "NS Go ready"){
    /*YOUR CODE HERE*/




  }
  else if(state == "NS Stopping"){
    /*YOUR CODE HERE*/




  }
  else if(state == "NS Stopping carNS"){
    /*YOUR CODE HERE*/




  }
  else if(state == "EW Go"){
    /*YOUR CODE HERE*/




  }
  else if(state == "EW Go must change"){
    /*YOUR CODE HERE*/




  } 
  //End of actions and transitions

   
  if(timerExpired == true){ // Reset the timer 
    timerExpired = false;   
  }
}

/** Make the N-S lights be red */
void turnNSred(){
    /*YOUR CODE HERE*/


}

/** Make the N-S lights be amber */
void turnNSamber(){
    /*YOUR CODE HERE*/


}

/** Make the N-S lights be green */
void turnNSgreen(){
    /*YOUR CODE HERE*/


}


/** Make the E-W lights be red */
void turnEWred(){
  digitalWrite(redEW, HIGH);
  digitalWrite(yellowEW, LOW);
  digitalWrite(greenEW, LOW); 
}

/** Make the E-W lights be amber */
void turnEWamber(){
  digitalWrite(redEW, LOW);
  digitalWrite(yellowEW, HIGH);
  digitalWrite(greenEW, LOW);  
}

/** Make the E-W lights be green */
void turnEWgreen(){
  digitalWrite(redEW, LOW);
  digitalWrite(yellowEW, LOW);
  digitalWrite(greenEW, HIGH);  
}

/** Reset the timer to count down the specified number of milliseconds */
void restartTimer(unsigned long milliseconds) {
    timerExpired = false;   // tell the controller that the timer ran out.
    timerEnd = milliseconds;
    timerStart = millis();
}

/** Check if timer expired */
void checkTimer() {
    if (millis() - timerStart > timerEnd) {
        timerEnd = 0;
        timerExpired = true;   // tell the controller that the timer ran out.
    }
}

//***** YOU DO NOT NEED TO READ HERE
//if CarNS button is not pushed function will return LOW (0).
//if it is pushed function will return HIGH (1).
int readCarNS(){
   //read button state. HIGH is pushed, LOW is not pushed.
  int carNS_read = digitalRead(carNS_pin);

  // If the switch changed, due to noise or pressing:
  if ( carNS_read != carNS_Switch_prev ) {
    // reset the debouncing timer
    carNS_last_debounce = millis();
  }
  if ( millis() > (carNS_last_debounce + debounce_delay) ) {
    // whatever the reading is at, it's been there for longer
    // than the debounce delay, so take it as the actual current state:

    // if the button state has changed:
    if ( carNS_read != carNS_Switch_state ) {
      // save the reading.  Next time through the loop,
      carNS_Switch_state = carNS_read;
      if ( carNS_Switch_state == HIGH ) { 
        return HIGH;
      }
    }
  }
  // Remember the previous states for next loop
  carNS_Switch_prev = carNS_read;
  return LOW;
}

//if CarEW button is not pushed function will return LOW (0).
//if it is pushed function will return HIGH (1).
int readCarEW(){
   //read button state. HIGH is pushed, LOW is not pushed.
  int carEW_read = digitalRead(carEW_pin);

  // If the switch changed, due to noise or pressing:
  if ( carEW_read != carEW_Switch_prev ) {
    // reset the debouncing timer
    carEW_last_debounce = millis();
  }
  if ( millis() > (carEW_last_debounce + debounce_delay) ) {
    // whatever the reading is at, it's been there for longer
    // than the debounce delay, so take it as the actual current state:

    // if the button state has changed:
    if ( carEW_read != carEW_Switch_state ) {
      // save the reading.  Next time through the loop,
      carEW_Switch_state = carEW_read;
      if ( carEW_Switch_state == HIGH ) { 
        return HIGH;
      }
    }
  }
  // Remember the previous states for next loop
  carEW_Switch_prev = carEW_read;
  return LOW;
}
